/******************************************************************************/
/* TEKNISA                                                                    */
/******************************************************************************/
/*                                                                            */
/* NOME: INSERE_SERVICO_AGREGADA                                              */
/*                                                                            */
/* DESCRIO:                                                                 */
/*   Insere o servio utilizado na retirada para a agregada.                  */
/*                                                                            */
/* CRIAO:                                                                   */
/*   20/05/2005 - Luiz Otvio de Souza                                        */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER INSERE_SERVICO_AGREGADA
BEFORE INSERT
ON CARDADIA FOR EACH ROW

DECLARE
   V_CONTSERV     NUMBER;
   V_CDFILCENTPME VARCHAR2(04);
   V_NMSERVICO    VARCHAR2(40);
   V_CDSERVFILI   VARCHAR2(05);
BEGIN
   /*Verifica se o servio j existe para a agregada*/

   SELECT MAX(CDSERVFILI)
   INTO V_CDSERVFILI
   FROM SERVICO
   WHERE (CDFILIAL   = :NEW.CDFILIAL)   AND
         (CDSERVFILI = :NEW.CDSERVFILI);

   IF (V_CDSERVFILI IS NULL) THEN
      /*Retorna a central da agregada*/
      SELECT MAX(CDFILCENTPME)
      INTO V_CDFILCENTPME
      FROM FILIAL
      WHERE (CDFILIAL = :NEW.CDFILIAL);

      IF NOT V_CDFILCENTPME IS NULL THEN
         /*Retorna a nome do servico*/
         SELECT MAX(NMSERVICO)
         INTO V_NMSERVICO
         FROM SERVICO
         WHERE (CDFILIAL   = V_CDFILCENTPME) AND
               (CDSERVFILI = :NEW.CDSERVFILI);

         IF NOT V_NMSERVICO IS NULL THEN
            INSERT INTO SERVICO
            (CDFILIAL, CDSERVFILI, NMSERVICO, IDTIPOSERV)
            VALUES
            (:NEW.CDFILIAL, :NEW.CDSERVFILI, V_NMSERVICO, 'M');
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('INSERE_SERVICO_AGREGADA','4.06.040'); END;
/

