IF EXISTS(SELECT *
            FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_DFS_AUTOOBTERXMLGER' 
             AND TYPE   = 'TR'
             AND U.UID  = O.UID
             AND U.NAME = USER)

   DROP TRIGGER LOG_DFS_AUTOOBTERXMLGER
GO

CREATE TRIGGER LOG_DFS_AUTOOBTERXMLGER
ON AUTOOBTERXMLGER
FOR UPDATE, INSERT, DELETE
AS
BEGIN
   DECLARE @V_USUARIO      VARCHAR(40);
   DECLARE @V_TIPO         VARCHAR(01);
   DECLARE @V_TPMOVI       VARCHAR(01);
   DECLARE @V_ITPESQ       VARCHAR(40);
   DECLARE @V_DESC         VARCHAR(700);
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DTOPER       DATETIME;

   /* ****INCIO DAS VARIVEIS DO C_CURSOR***** */
   DECLARE @V_OLD_NRINSJURAUTOXML VARCHAR(14);
   DECLARE @V_OLD_DSOBSAUTOXML    VARCHAR(255);
  
   DECLARE @V_NEW_NRINSJURAUTOXML VARCHAR(14);
   DECLARE @V_NEW_DSOBSAUTOXML    VARCHAR(255);
   /* ****FINAL DAS VARIVEIS DO C_CURSOR***** */

   SET @V_TIPO = '0';
   SET @V_DESC = '';

   DECLARE C_CURSOR CURSOR FOR
      SELECT 
         'D' IDCOMANDO,
         NULL,
         NULL,
         DELETED.NRINSJURAUTOXML,
         DELETED.DSOBSAUTOXML
      FROM
         DELETED
      WHERE
         0 = (SELECT 
                 COUNT(*) 
              FROM 
                 INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.NRINSJURAUTOXML,
         INSERTED.DSOBSAUTOXML,
         DELETED.NRINSJURAUTOXML,
         DELETED.DSOBSAUTOXML
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.NRINSJURAUTOXML = DELETED.NRINSJURAUTOXML

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.NRINSJURAUTOXML,
         INSERTED.DSOBSAUTOXML,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT 
                 COUNT(*) 
              FROM 
                 DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_TIPO, 
                                 @V_NEW_NRINSJURAUTOXML,
                                 @V_NEW_DSOBSAUTOXML,
                                 @V_OLD_NRINSJURAUTOXML,
                                 @V_OLD_DSOBSAUTOXML;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      /* DELETE */
      IF @V_TIPO = 'D' BEGIN
         SET @V_TPMOVI = '3';
         SET @V_ITPESQ = @V_OLD_NRINSJURAUTOXML;
         
         IF @V_OLD_NRINSJURAUTOXML IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrInsJurAutoXML=' + @V_OLD_NRINSJURAUTOXML;
         END;

         IF @V_OLD_DSOBSAUTOXML IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DsObsAutoXML=' + @V_OLD_DSOBSAUTOXML;
         END;
      END
      ELSE BEGIN
         /* UPDATE */
         IF @V_TIPO = 'U' BEGIN
            IF (ISNULL(@V_OLD_NRINSJURAUTOXML, '!') <> ISNULL(@V_NEW_NRINSJURAUTOXML, '!')) OR
               (ISNULL(@V_OLD_DSOBSAUTOXML, '!')    <> ISNULL(@V_NEW_DSOBSAUTOXML, '!'))
            BEGIN
               SET @V_TPMOVI = '2';
               SET @V_ITPESQ = @V_OLD_NRINSJURAUTOXML;
            END;
         END
         ELSE BEGIN
            /* INSERT */
            SET @V_TPMOVI = '1';
            SET @V_ITPESQ = @V_NEW_NRINSJURAUTOXML;
         END;

         IF ISNULL(@V_NEW_NRINSJURAUTOXML, '!') <> ISNULL(@V_OLD_NRINSJURAUTOXML, '!') BEGIN
            SET @V_DESC = @V_DESC + ' NrInsJurAutoXML=' + @V_NEW_NRINSJURAUTOXML;
         END;

         IF ISNULL(@V_NEW_DSOBSAUTOXML, '!') <> ISNULL(@V_OLD_DSOBSAUTOXML, '!') BEGIN
            SET @V_DESC = @V_DESC + ' DsObsAutoXML=' + @V_NEW_DSOBSAUTOXML;
         END;
      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @P_NMUSUARIO    = @V_USUARIO OUTPUT;
         EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                         @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                         @P_DSSERVERRDM  = @V_DSSERVERRDM  OUTPUT,
                         @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                         @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;
         SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,
                   DTOPERACAO,
                   NMRESPOPER,
                   IDTIPOOPER,
                   CDPESQITEM,
                   DSOPERACAO,
                   DSRDMUSUOPER,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  ('AUTOOBTERXMLGER',
                   @V_DTOPER,
                   @V_USUARIO,
                   @V_TPMOVI,
                   @V_ITPESQ,
                   SUBSTRING(@V_DESC,1,700),
                   @V_DSSERVERRDM,
                   @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_TIPO, 
                                    @V_NEW_NRINSJURAUTOXML,
                                    @V_NEW_DSOBSAUTOXML,
                                    @V_OLD_NRINSJURAUTOXML,
                                    @V_OLD_DSOBSAUTOXML;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_DFS_AUTOOBTERXMLGER','5.85.xxx';
GO
