CREATE OR REPLACE PROCEDURE GERA_AJUSTE_AUTO(
   P_CDIMPOSTO    IN MAPAAPURAC.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN MAPAAPURAC.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN MAPAAPURAC.CDINSCESTA%TYPE,
   P_NRSEQUMAPAPU IN MAPAAPURAC.NRSEQUMAPAPU%TYPE)
AS
   V_VRENTRADA         NUMBER;
   V_VRBASEENTR        NUMBER;
   V_VRIMPENTRADA      NUMBER;
   V_VRFECPENTR        NUMBER;
   V_VRSAIDANOTA       NUMBER;
   V_VRSAIDAVENDA      NUMBER;
   V_VRBASESAIDNOTA    NUMBER;
   V_VRBASESAIDVENDA   NUMBER;
   V_VRIMPSAIDANOTA    NUMBER;
   V_VRIMPSAIDAVENDA   NUMBER;
   V_VRFECPSAIDNOTA    NUMBER;
   V_VRFECPSAIDVENDA   NUMBER;
   V_VRCONTABIL        NUMBER;
   V_VRBASECALC        NUMBER;
   V_VRIMPOSTO         NUMBER;
   V_VRFECP            NUMBER;
   V_VRAJUSTE          NUMBER;
   V_NRSEQAJUSTE       ITMAPARECUP.NRSEQITMAPR%TYPE;
   V_CDFILIAL          ITEMPROIMPOS.CDFILIAL%TYPE;
   V_NRLANCTONF        ITEMPROIMPOS.NRLANCTONF%TYPE;
   V_NRSEQDETITMAPA    DETITMAPARECUP.NRSEQDETITMAPA%TYPE;
   V_CDIMPOSTO         IMPOSTO.CDIMPOSTO%TYPE;
   V_VRAJUSTEDOC       NUMBER;
   V_VRAJUSTETOT       NUMBER;
   V_SQLFORMULA        VARCHAR2(500);
   V_FILIRATEIO        FILIAL.CDFILIAL%TYPE;

   PROCEDURE INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU IN MAPAAPURAC.NRSEQUMAPAPU%TYPE,
                                   P_IDTPAJUSTE   IN AJUSTFISCAUTO.IDTPAJUSTE%TYPE,
                                   P_NRSEQAJUSTE  IN ITMAPARECUP.NRSEQITMAPR%TYPE,
                                   P_VRRATEIOAJ   IN ITMAPARECUP.VRITEMMAPR%TYPE,
                                   P_CDFILIREATIO IN NOTAFISCAL.CDFILIAL%TYPE)
   IS
      V_NRSEQRATEIO  VARCHAR2(20);
   BEGIN
      NOVO_CODIGO_NT('RATEIOAJUSTEMAPA', V_NRSEQRATEIO);
      IF P_IDTPAJUSTE = 'IA' THEN
         INSERT INTO RATEIOAJUSTEMAPA
            (NRSEQRATEIO, NRSEQUMAPAPU, IDTPAJUSTE, NRSEQAJUSTE, VRRATEIOAJ, CDFILIRATEIO)
         VALUES
            (V_NRSEQRATEIO, P_NRSEQUMAPAPU, P_IDTPAJUSTE, LPAD(P_NRSEQAJUSTE,5,'0'), P_VRRATEIOAJ, P_CDFILIREATIO);
      ELSE
         INSERT INTO RATEIOAJUSTEMAPA
            (NRSEQRATEIO, NRSEQUMAPAPU, IDTPAJUSTE, NRSEQAJUSTE, VRRATEIOAJ, CDFILIRATEIO)
         VALUES
            (V_NRSEQRATEIO, P_NRSEQUMAPAPU, P_IDTPAJUSTE, LPAD(P_NRSEQAJUSTE,10,'0'), P_VRRATEIOAJ, P_CDFILIREATIO);
      END IF;
   END;
BEGIN
   /*APAGA OS VALORES INSERIDOS EM OUTRAS APURAES PARA O CASO DE REAPURAO DE MAPA*/
   DELETE FROM ITMAPARECUP
    WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU
      AND IDAJUSTEAUTO = 'S';

   DELETE FROM INFADICMAPA
    WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU
      AND IDORIGEMINF  = 'A';

   /*BUSCA O CDIGO DO IMPOSTO PARA INSERIR OS AJUSTES*/
   BEGIN
      SELECT MIN(CDIMPOSTO)
        INTO V_CDIMPOSTO
        FROM IMPOSTO
       WHERE CDIMPOSTONFE = P_CDIMPOSTO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDIMPOSTO := NULL;
   END;
   /*BUSCA A PARAMETRIZAO DE AJUSTE AUTOMTICO PARA O IMPOSTO QUE EST SENDO APURADO*/
   FOR C_AJUSTEAUTO IN (SELECT A.CDAJUSTFISC, A.IDTPAJUSTE, A.IDTIPOCALC, A.IDTIPOCALCDOC, A.IDTIPOCONT,
                               A.CDCONTRATEIO, A.CDAJUSTEEEFD, A.DSAJUSTEEFDICMS, F.CDCRITAJUSTE, F.DSFORMULA,
                               R.IDRATEIOPADRAO
                          FROM AJUSTFISCAUTO A, FORMAJUSTFISC F, RATEIOPADRAOFIS R
                         WHERE A.CDEMPRESA    = P_CDEMPRESA
                           AND A.CDINSCESTA   = P_CDINSCESTA
                           AND A.CDIMPOSTONFE = P_CDIMPOSTO
                           AND A.CDFORMULA    = F.CDFORMULA
                           AND F.CDCRITAJUSTE = R.CDRATEIOPADRAO) LOOP

       /*BUSCA O MAIOR SEQUENCIAL DO TIPO DE AJUSTE A SER INSERIDO*/
       V_NRSEQAJUSTE := 0;
       IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
          BEGIN
             SELECT MAX(NRSEQINFADIC)
               INTO V_NRSEQAJUSTE
               FROM INFADICMAPA
              WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_NRSEQAJUSTE := 0;
          END;
       ELSE
          BEGIN
             SELECT MAX(I.NRSEQITMAPR)
               INTO V_NRSEQAJUSTE
               FROM ITMAPARECUP I
              WHERE I.NRSEQUMAPAPU = P_NRSEQUMAPAPU
                AND I.IDTIPOITMAPR = C_AJUSTEAUTO.IDTPAJUSTE;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_NRSEQAJUSTE := 0;
          END;
       END IF;

       V_VRCONTABIL := 0;
       V_VRBASECALC := 0;
       V_VRIMPOSTO  := 0;
       V_VRFECP     := 0;

       /*FORMA DE CLCULO SOBRE O VALOR TOTAL*/
       IF C_AJUSTEAUTO.IDTIPOCALC = 'T' THEN
          /*VERIFICA SE A FRMULA CONSIDERA OS VALORES CONTBEIS, DE BASE OU IMPOSTO, PARA BUSCAR OS VALORES NAS NOTAS DO PERODO*/
          IF INSTR(C_AJUSTEAUTO.DSFORMULA,'C') > 0 OR INSTR(C_AJUSTEAUTO.DSFORMULA,'B') > 0 OR INSTR(C_AJUSTEAUTO.DSFORMULA,'I') > 0 THEN
             BEGIN
                SELECT NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',II.VRCONTITIMP,0)),0) AS VRENTRADA,
                       NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',DECODE(II.CDFISCALIT,'1',II.VRBASECALCIT,0),0)),0) AS VRBASEENTR,
                       NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',DECODE(II.CDFISCALIT,'1',II.VRIMPOSTOIT,0),0)),0) AS VRIMPENTRADA,
                       NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',DECODE(II.CDFISCALIT,'1',II.VRADICFECP,0),0)),0) AS VRFECPENTR,
                       NVL(SUM(DECODE(NF.IDENTRSAIDOP,'S',II.VRCONTITIMP,0)),0) AS VRSAIDA,
                       NVL(SUM(DECODE(NF.IDENTRSAIDOP,'S',DECODE(II.CDFISCALIT,'1',II.VRBASECALCIT,0),0)),0) AS VRBASESAID,
                       NVL(SUM(DECODE(NF.IDENTRSAIDOP,'S',DECODE(II.CDFISCALIT,'1',II.VRIMPOSTOIT,0),0)),0) AS VRIMPSAIDA,
                       NVL(SUM(DECODE(NF.IDENTRSAIDOP,'S',DECODE(II.CDFISCALIT,'1',II.VRADICFECP,0),0)),0) AS VRFECPSAIDA
                  INTO V_VRENTRADA,   V_VRBASEENTR,     V_VRIMPENTRADA,   V_VRFECPENTR,
                       V_VRSAIDANOTA, V_VRBASESAIDNOTA, V_VRIMPSAIDANOTA, V_VRFECPSAIDNOTA
                  FROM ITEMPROIMPOS II, ITEMPRODUTO IT, PRODUTO PR, IMPOSTO IM, NOTAFISCAL NF,
                       (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                          FROM IMPOSTONF I
                         WHERE I.NRSEQUMAPAPU = P_NRSEQUMAPAPU) IP,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDTIPOOPER
                          FROM RATFISTPOPERAC R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISTPOPERAC R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'E')
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISTPOPERAC R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RT,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCFOPPADRAO
                          FROM RATFISCFOPPADRAO R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISCFOPPADRAO R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'E')
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISCFOPPADRAO R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RC,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDPRODUTO
                          FROM RATFISPRODUTO R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISPRODUTO R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'E')
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISPRODUTO R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RP,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.IDTPPART, R.CDPARTICIPANTE
                          FROM RATFISPARTICIP R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISPARTICIP R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'E')
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISPARTICIP R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RF,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCST
                          FROM RATFISCST R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISCST R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'E')
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISCST R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RS,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.VRALIQUOTA
                          FROM RATFISALIQ R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', -1 FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISALIQ R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'E')
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', -1 FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISALIQ R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RL,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCLASFISC
                          FROM RATFISNCM R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISNCM R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'E')
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISNCM R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RN
                 WHERE IP.CDFILIAL       = II.CDFILIAL
                   AND IP.NRLANCTONF     = II.NRLANCTONF
                   AND II.CDIMPOSTO      = IM.CDIMPOSTO
                   AND IM.CDIMPOSTONFE   = P_CDIMPOSTO
                   AND NVL(II.NRITPROIMPOS,'1') <> '3'
                   AND II.CDFILIAL       = NF.CDFILIAL
                   AND II.NRLANCTONF     = NF.NRLANCTONF
                   AND RT.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RT.IDENTRSAIDOP
                   AND (NF.CDTIPOOPER = RT.CDTIPOOPER OR RT.CDTIPOOPER = 'T')
                   AND RC.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RC.IDENTRSAIDOP
                   AND (II.CDFISCOPERIT = RC.CDCFOPPADRAO OR RC.CDCFOPPADRAO = 'T')
                   AND II.CDFILIAL       = IT.CDFILIAL
                   AND II.NRLANCTONF     = IT.NRLANCTONF
                   AND II.NRSEQITPROD    = IT.NRSEQITPROD
                   AND RP.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RP.IDENTRSAIDOP
                   AND (IT.CDPRODUTO = RP.CDPRODUTO OR RP.CDPRODUTO = 'T')
                   AND RS.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RS.IDENTRSAIDOP
                   AND (II.CDSITUTRIBITNFE = RS.CDCST OR RS.CDCST = 'T')
                   AND RL.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RL.IDENTRSAIDOP
                   AND (II.VRALIQITEM = RL.VRALIQUOTA OR RL.VRALIQUOTA = -1)
                   AND IT.CDPRODUTO      = PR.CDPRODUTO
                   AND RN.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RN.IDENTRSAIDOP
                   AND (NVL(IT.CDPRODNCMTRANS,PR.CDCLASFISC) = RN.CDCLASFISC OR RN.CDCLASFISC = 'T')
                   AND RF.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RF.IDENTRSAIDOP
                   AND ((NF.IDORIGDESTNF = RF.IDTPPART AND CASE WHEN NF.IDORIGDESTNF = 'F' THEN NF.CDFORNECED
                                                                WHEN NF.IDORIGDESTNF = 'C' THEN NF.CDCLIENTE
                                                                WHEN NF.IDORIGDESTNF = 'L' AND NF.IDENTRSAIDOP = 'E' THEN NF.CDFILIEMIT
                                                                WHEN NF.IDORIGDESTNF = 'L' AND NF.IDENTRSAIDOP = 'S' THEN NF.CDFILIRECE
                                                           END = RF.CDPARTICIPANTE) OR (RF.CDPARTICIPANTE = 'T'));
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_VRENTRADA      := 0;
                   V_VRBASEENTR     := 0;
                   V_VRIMPENTRADA   := 0;
                   V_VRFECPENTR     := 0;
                   V_VRSAIDANOTA    := 0;
                   V_VRBASESAIDNOTA := 0;
                   V_VRIMPSAIDANOTA := 0;
                   V_VRFECPSAIDNOTA := 0;
             END;

             BEGIN
                SELECT NVL(SUM(TRUNC((IT.QTPRODVEND  * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2)),0) AS VRSAIDA,
                       NVL(SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T'
                                THEN CASE WHEN II.VRPRBCREDUICMS > 0
                                          THEN II.VRBASECALCREDUZ
                                          ELSE TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2) END
                                ELSE 0 END),0) AS VRBASESAID,
                       NVL(SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T'
                                THEN CASE WHEN II.VRPRBCREDUICMS > 0
                                          THEN NVL(II.VRIMPOPRODREDUZ,0)
                                          ELSE NVL(VRIMPOPRODIT,0) END
                                ELSE 0 END),0) AS VRIMPSAIDA,
                       NVL(SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T'
                                THEN NVL(II.VRIMPICMSFCP,0)
                                ELSE 0 END),0) AS VRFECPSAID
                  INTO V_VRSAIDAVENDA, V_VRBASESAIDVENDA, V_VRIMPSAIDAVENDA, V_VRFECPSAIDVENDA
                  FROM ITVENDAIMPOS II, ITEMVENDA IT, PRODUTO PR, IMPOSTO IM, NOTAFISCAL NF, RATEIOPADRAOFIS RA,
                       (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF, R.CDFILIALVENDA, R.CDCAIXA, R.NRSEQVENDA
                          FROM IMPOSTONF I, RELACNFCEAPROV R, VENDA V
                         WHERE I.NRSEQUMAPAPU  = P_NRSEQUMAPAPU
                           AND I.CDFILIAL      = R.CDFILIALNOTA
                           AND I.NRLANCTONF    = R.NRLANCTONF
                           AND R.CDFILIALVENDA = V.CDFILIAL
                           AND R.CDCAIXA       = V.CDCAIXA
                           AND R.NRSEQVENDA    = V.NRSEQVENDA
                           AND V.IDSITUVENDA   = 'O') IP,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDTIPOOPER
                          FROM RATFISTPOPERAC R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISTPOPERAC R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RT,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCFOPPADRAO
                          FROM RATFISCFOPPADRAO R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISCFOPPADRAO R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RC,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDPRODUTO
                          FROM RATFISPRODUTO R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISPRODUTO R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RP,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.IDTPPART, R.CDPARTICIPANTE
                          FROM RATFISPARTICIP R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISPARTICIP R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RF,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCST
                          FROM RATFISCST R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISCST R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RS,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.VRALIQUOTA
                          FROM RATFISALIQ R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', -1 FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISALIQ R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RL,
                       (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCLASFISC
                          FROM RATFISNCM R
                         WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                         UNION ALL
                        SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                         WHERE NOT EXISTS (SELECT * FROM RATFISNCM R
                                            WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                              AND R.IDENTRSAIDOP   = 'S')) RN
                 WHERE IP.CDFILIALVENDA       = II.CDFILIAL
                   AND IP.CDCAIXA        = II.CDCAIXA
                   AND IP.NRSEQVENDA     = II.NRSEQVENDA
                   AND II.CDIMPOSTO      = IM.CDIMPOSTO
                   AND IP.CDFILIAL       = NF.CDFILIAL
                   AND IP.NRLANCTONF     = NF.NRLANCTONF
                   AND RT.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RT.IDENTRSAIDOP
                   AND (NF.CDTIPOOPER    = RT.CDTIPOOPER OR RT.CDTIPOOPER = 'T')
                   AND RC.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RC.IDENTRSAIDOP
                   AND (II.CDCFOPPROD    = RC.CDCFOPPADRAO OR RC.CDCFOPPADRAO = 'T')
                   AND II.CDFILIAL       = IT.CDFILIAL
                   AND II.CDCAIXA        = IT.CDCAIXA
                   AND II.NRSEQVENDA     = IT.NRSEQVENDA
                   AND II.NRSEQUITVEND   = IT.NRSEQUITVEND
                   AND RP.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RP.IDENTRSAIDOP
                   AND (IT.CDPRODUTO     = RP.CDPRODUTO OR RP.CDPRODUTO = 'T')
                   AND RS.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RS.IDENTRSAIDOP
                   AND (II.CDCSTPRODI    = RS.CDCST OR RS.CDCST = 'T')
                   AND RL.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RL.IDENTRSAIDOP
                   AND (II.VRPEALPRODIT  = RL.VRALIQUOTA OR RL.VRALIQUOTA = -1)
                   AND IT.CDPRODUTO      = PR.CDPRODUTO
                   AND RN.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RN.IDENTRSAIDOP
                   AND (NVL(IT.CDCLASFISC,PR.CDCLASFISC) = RN.CDCLASFISC OR RN.CDCLASFISC = 'T')
                   AND RF.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                   AND NF.IDENTRSAIDOP   = RF.IDENTRSAIDOP
                   AND ((NF.IDORIGDESTNF = RF.IDTPPART AND CASE WHEN NF.IDORIGDESTNF = 'F' THEN NF.CDFORNECED
                                                                WHEN NF.IDORIGDESTNF = 'C' THEN NF.CDCLIENTE
                                                                WHEN NF.IDORIGDESTNF = 'L' AND NF.IDENTRSAIDOP = 'S' THEN NF.CDFILIRECE
                                                            END = RF.CDPARTICIPANTE) OR (RF.CDPARTICIPANTE = 'T'));
             EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                    V_VRSAIDAVENDA    := 0;
                    V_VRBASESAIDVENDA := 0;
                    V_VRIMPSAIDAVENDA := 0;
                    V_VRFECPSAIDVENDA := 0;
             END;

             CASE C_AJUSTEAUTO.IDRATEIOPADRAO
                WHEN 'ENT' THEN V_VRCONTABIL := NVL(V_VRENTRADA,0);
                WHEN 'SAI' THEN V_VRCONTABIL := NVL(V_VRSAIDANOTA,0) + NVL(V_VRSAIDAVENDA,0);
                WHEN 'SME' THEN V_VRCONTABIL := NVL(V_VRSAIDANOTA,0) + NVL(V_VRSAIDAVENDA,0) - NVL(V_VRENTRADA,0);
                ELSE V_VRCONTABIL := 0;
             END CASE;

             CASE C_AJUSTEAUTO.IDRATEIOPADRAO
                WHEN 'ENT' THEN V_VRBASECALC := NVL(V_VRBASEENTR,0);
                WHEN 'SAI' THEN V_VRBASECALC := NVL(V_VRBASESAIDNOTA,0) + NVL(V_VRBASESAIDVENDA,0);
                WHEN 'SME' THEN V_VRBASECALC := NVL(V_VRBASESAIDNOTA,0) + NVL(V_VRBASESAIDVENDA,0) - NVL(V_VRBASEENTR,0);
                ELSE V_VRBASECALC := 0;
             END CASE;

             CASE C_AJUSTEAUTO.IDRATEIOPADRAO
                WHEN 'ENT' THEN V_VRIMPOSTO := NVL(V_VRIMPENTRADA,0);
                WHEN 'SAI' THEN V_VRIMPOSTO := NVL(V_VRIMPSAIDANOTA,0) + NVL(V_VRIMPSAIDAVENDA,0);
                WHEN 'SME' THEN V_VRIMPOSTO := NVL(V_VRIMPSAIDANOTA,0) + NVL(V_VRIMPSAIDAVENDA,0) - NVL(V_VRIMPENTRADA,0);
                ELSE V_VRIMPOSTO := 0;
             END CASE;

             CASE C_AJUSTEAUTO.IDRATEIOPADRAO
                WHEN 'ENT' THEN V_VRFECP := NVL(V_VRFECPENTR,0);
                WHEN 'SAI' THEN V_VRFECP := NVL(V_VRFECPSAIDNOTA,0) + NVL(V_VRFECPSAIDVENDA,0);
                WHEN 'SME' THEN V_VRFECP := NVL(V_VRFECPSAIDNOTA,0) + NVL(V_VRFECPSAIDVENDA,0) - NVL(V_VRFECPENTR,0);
                ELSE V_VRFECP := 0;
             END CASE;
          END IF;

          /******** Monta o select, considerando a frmula cadastrada pelo usurio ********/
          V_SQLFORMULA := 'SELECT ' || C_AJUSTEAUTO.DSFORMULA || ' AS VRAJUSTE
                             FROM (SELECT ' || REPLACE(V_VRIMPOSTO, ',','.') || ' AS I,
                                          ' || REPLACE(V_VRBASECALC,',','.') || ' AS B,
                                          ' || REPLACE(V_VRCONTABIL,',','.') || ' AS C,
                                          ' || REPLACE(V_VRFECP,    ',','.') || ' AS F
                                     FROM DUAL)';

          /******** Executa o select e faz o tratamento de erros ********/
          BEGIN
             EXECUTE IMMEDIATE V_SQLFORMULA INTO V_VRAJUSTE;
          EXCEPTION
             WHEN OTHERS THEN
                RAISE_APPLICATION_ERROR(-20501,V_SQLFORMULA||'_'||SQLERRM(SQLCODE),TRUE);
          END;

          IF V_VRAJUSTE > 0 THEN
             V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
             IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                INSERT INTO INFADICMAPA
                   (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                VALUES
                   (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTE,2));
             ELSE
                INSERT INTO ITMAPARECUP
                   (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                    NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                VALUES
                   (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTE,2),
                    '','', C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'N');
             END IF;
          END IF;
       /*FORMA DE CLCULO SOBRE DOCUMENTO*/
       ELSE
          /*INICIALIZA AS VARIVEIS DA ROTINA*/
          V_VRCONTABIL := 0;
          V_VRBASECALC := 0;
          V_VRIMPOSTO  := 0;
          V_VRFECP     := 0;
          V_CDFILIAL   := NULL;
          V_NRLANCTONF := NULL;
          V_VRAJUSTE   := 0;
          /*AJUSTES NAS ENTRADAS*/
          IF (C_AJUSTEAUTO.IDRATEIOPADRAO = 'ENT') OR (C_AJUSTEAUTO.IDRATEIOPADRAO = 'SME') THEN
             FOR C_ITEM IN (SELECT NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',II.VRCONTITIMP,0)),0) AS VRENTRADA,
                                   NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',DECODE(II.CDFISCALIT,'1',II.VRBASECALCIT,0),0)),0) AS VRBASEENTR,
                                   NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',DECODE(II.CDFISCALIT,'1',II.VRIMPOSTOIT, 0),0)),0) AS VRIMPENTRADA,
                                   NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',DECODE(II.CDFISCALIT,'1',II.VRADICFECP,  0),0)),0) AS VRFECPENTR,
                                   II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, NF.CDFILIRECE AS CDFILIRATEIO
                              FROM ITEMPROIMPOS II, ITEMPRODUTO IT, PRODUTO PR, IMPOSTO IM, NOTAFISCAL NF,
                                   (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                      FROM IMPOSTONF I
                                     WHERE I.NRSEQUMAPAPU = P_NRSEQUMAPAPU) IP,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDTIPOOPER
                                      FROM RATFISTPOPERAC R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISTPOPERAC R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'E')) RT,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCFOPPADRAO
                                      FROM RATFISCFOPPADRAO R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISCFOPPADRAO R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'E')) RC,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDPRODUTO
                                      FROM RATFISPRODUTO R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISPRODUTO R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'E')) RP,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.IDTPPART, R.CDPARTICIPANTE
                                      FROM RATFISPARTICIP R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISPARTICIP R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'E')) RF,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCST
                                      FROM RATFISCST R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISCST R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'E')) RS,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.VRALIQUOTA
                                      FROM RATFISALIQ R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', -1 FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISALIQ R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'E')) RL,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCLASFISC
                                      FROM RATFISNCM R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'E', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISNCM R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'E')) RN
                             WHERE IP.CDFILIAL       = II.CDFILIAL
                               AND IP.NRLANCTONF     = II.NRLANCTONF
                               AND II.CDIMPOSTO      = IM.CDIMPOSTO
                               AND IM.CDIMPOSTONFE   = P_CDIMPOSTO
                               AND NVL(II.NRITPROIMPOS,'1') <> '3'
                               AND II.CDFILIAL       = NF.CDFILIAL
                               AND II.NRLANCTONF     = NF.NRLANCTONF
                               AND NF.IDENTRSAIDOP   = 'E'
                               AND RT.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RT.IDENTRSAIDOP
                               AND (NF.CDTIPOOPER = RT.CDTIPOOPER OR RT.CDTIPOOPER = 'T')
                               AND RC.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RC.IDENTRSAIDOP
                               AND (II.CDFISCOPERIT = RC.CDCFOPPADRAO OR RC.CDCFOPPADRAO = 'T')
                               AND II.CDFILIAL       = IT.CDFILIAL
                               AND II.NRLANCTONF     = IT.NRLANCTONF
                               AND II.NRSEQITPROD    = IT.NRSEQITPROD
                               AND RP.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RP.IDENTRSAIDOP
                               AND (IT.CDPRODUTO = RP.CDPRODUTO OR RP.CDPRODUTO = 'T')
                               AND RS.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RS.IDENTRSAIDOP
                               AND (II.CDSITUTRIBITNFE = RS.CDCST OR RS.CDCST = 'T')
                               AND RL.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RL.IDENTRSAIDOP
                               AND (II.VRALIQITEM = RL.VRALIQUOTA OR RL.VRALIQUOTA = -1)
                               AND IT.CDPRODUTO      = PR.CDPRODUTO
                               AND RN.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RN.IDENTRSAIDOP
                               AND (NVL(IT.CDPRODNCMTRANS,PR.CDCLASFISC) = RN.CDCLASFISC OR RN.CDCLASFISC = 'T')
                               AND RF.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RF.IDENTRSAIDOP
                               AND ((NF.IDORIGDESTNF = RF.IDTPPART AND CASE WHEN NF.IDORIGDESTNF = 'F' THEN NF.CDFORNECED
                                                                            WHEN NF.IDORIGDESTNF = 'C' THEN NF.CDCLIENTE
                                                                            WHEN NF.IDORIGDESTNF = 'L' THEN NF.CDFILIEMIT END = RF.CDPARTICIPANTE)
                                                                    OR (RF.CDPARTICIPANTE = 'T'))
                             GROUP BY II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, NF.CDFILIRECE
                             ORDER BY II.CDFILIAL, II.NRLANCTONF) LOOP

                /*FAZ O CLCULO DO AJUSTE ITEM A ITEM*/
                V_VRCONTABIL := NVL(C_ITEM.VRENTRADA,0);
                V_VRBASECALC := NVL(C_ITEM.VRBASEENTR,0);
                V_VRIMPOSTO  := NVL(C_ITEM.VRIMPENTRADA,0);
                V_VRFECP     := NVL(C_ITEM.VRFECPENTR,0);
                V_VRAJUSTE   := 0;

                /******** Monta o select, considerando a frmula cadastrada pelo usurio ********/
                V_SQLFORMULA := 'SELECT ' || C_AJUSTEAUTO.DSFORMULA || ' AS VRAJUSTE
                                   FROM (SELECT ' || REPLACE(V_VRIMPOSTO, ',','.') || ' AS I,
                                                ' || REPLACE(V_VRBASECALC,',','.') || ' AS B,
                                                ' || REPLACE(V_VRCONTABIL,',','.') || ' AS C,
                                                ' || REPLACE(V_VRFECP,    ',','.') || ' AS F
                                           FROM DUAL)';

                /******** Executa o select e faz o tratamento de erros ********/
                BEGIN
                   EXECUTE IMMEDIATE V_SQLFORMULA INTO V_VRAJUSTE;
                EXCEPTION
                   WHEN OTHERS THEN
                      RAISE_APPLICATION_ERROR(-20501,V_SQLFORMULA||'_'||SQLERRM(SQLCODE),TRUE);
                END;

                /*SALVA A FILIAL DO RATEIO EM UMA VARIVEL PORQUE O LTIMO AJUSTE POR DOCUMENTO PRECISAR SER INSERIDO FORA DO LOOP*/
                V_FILIRATEIO  := C_ITEM.CDFILIRATEIO;

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, MAS INSERIDO NO MAPA UM NICO AJUSTE*/
                IF C_AJUSTEAUTO.IDTIPOCALCDOC = 'T' THEN
                   V_VRAJUSTETOT := NVL(V_VRAJUSTETOT,0) + NVL(V_VRAJUSTE,0);
                   /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                   INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, NVL(V_NRSEQAJUSTE,0)+1, ROUND(V_VRAJUSTE,2), V_FILIRATEIO);

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, MAS INSERIDO NO MAPA UM AJUSTE POR NOTA FISCAL*/
                ELSIF C_AJUSTEAUTO.IDTIPOCALCDOC = 'D' THEN
                   IF (V_CDFILIAL||V_NRLANCTONF IS NULL) THEN
                      V_CDFILIAL   := C_ITEM.CDFILIAL;
                      V_NRLANCTONF := C_ITEM.NRLANCTONF;
                   END IF;
                   V_VRAJUSTEDOC :=  NVL(V_VRAJUSTEDOC,0) + NVL(V_VRAJUSTE,0);
                   IF (V_CDFILIAL||V_NRLANCTONF <> C_ITEM.CDFILIAL||C_ITEM.NRLANCTONF) THEN
                      IF V_VRAJUSTEDOC > 0 THEN
                         V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                         IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                            INSERT INTO INFADICMAPA
                               (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                            VALUES
                               (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2));
                         ELSE
                            INSERT INTO ITMAPARECUP
                               (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                                NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                            VALUES
                               (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2),
                                V_NRLANCTONF,V_CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'D');
                         END IF;
                         /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                         INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTEDOC,2), V_FILIRATEIO);
                      END IF;
                      V_CDFILIAL    := C_ITEM.CDFILIAL;
                      V_NRLANCTONF  := C_ITEM.NRLANCTONF;
                      V_VRAJUSTEDOC := 0;
                   END IF;

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, INSERIDO NO MAPA UM AJUSTE PARA CADA ITEM*/
                ELSIF C_AJUSTEAUTO.IDTIPOCALCDOC = 'I' THEN
                   IF (V_VRAJUSTE > 0) THEN
                      /*INSERE O AJUSTE PARA O ITEM QUANDO  VALOR INFORMATIVO*/
                      IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                         V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                         INSERT INTO INFADICMAPA
                            (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                         VALUES
                            (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTE,2));
                      ELSE
                         /*INSERE O AJUSTE PARA A NOTA, OU ATUALIZA O VALOR CASO J TENHA SIDO INCLUDO ALGUM ITEM PARA ESSA NOTA*/
                         IF (V_CDFILIAL||V_NRLANCTONF IS NULL) OR (V_CDFILIAL||V_NRLANCTONF <> C_ITEM.CDFILIAL||C_ITEM.NRLANCTONF) THEN
                            V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                            INSERT INTO ITMAPARECUP
                               (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                                NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                            VALUES
                               (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTE,2),
                                C_ITEM.NRLANCTONF, C_ITEM.CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'I');
                            V_CDFILIAL   := C_ITEM.CDFILIAL;
                            V_NRLANCTONF := C_ITEM.NRLANCTONF;
                         ELSE
                            UPDATE ITMAPARECUP
                               SET VRITEMMAPR = NVL(VRITEMMAPR,0) + ROUND(NVL(V_VRAJUSTE,0),2)
                             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU
                               AND IDTIPOITMAPR = C_AJUSTEAUTO.IDTPAJUSTE
                               AND NRSEQITMAPR  = LPAD(V_NRSEQAJUSTE,10,'0');
                         END IF;
                         /*INSERE O DETALHAMENTO DO ITEM*/
                         NOVO_CODIGO('DETITMAPARECUP',V_NRSEQDETITMAPA);
                         INSERT INTO DETITMAPARECUP
                            (NRSEQDETITMAPA, NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, CDFILIAL,
                             NRLANCTONF, NRSEQITPROD, CDIMPOSTO, VRIMPOSTOIT)
                         VALUES
                            (TO_NUMBER(V_NRSEQDETITMAPA), P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_ITEM.CDFILIAL,
                             C_ITEM.NRLANCTONF, C_ITEM.NRSEQITPROD, V_CDIMPOSTO, ROUND(V_VRAJUSTE,2));
                      END IF;
                      /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                      INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTE,2), V_FILIRATEIO);
                   END IF;
                END IF;
             END LOOP;
             /*INSERE O AJUSTE PARA A LTIMA NOTA, NO CASO DE AJUSTE POR DOCUMENTO*/
             IF (C_AJUSTEAUTO.IDTIPOCALCDOC = 'D') AND (V_VRAJUSTEDOC > 0) THEN
                V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                   INSERT INTO INFADICMAPA
                      (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                   VALUES
                      (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2));
                ELSE
                   INSERT INTO ITMAPARECUP
                      (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                       NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                   VALUES
                      (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2),
                       V_NRLANCTONF, V_CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'D');
                END IF;
                /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTEDOC,2), V_FILIRATEIO);
             END IF;
             /*INSERE O AJUSTE NO CASO DE AJUSTE NICO*/
             IF (C_AJUSTEAUTO.IDTIPOCALCDOC = 'T') AND (V_VRAJUSTETOT > 0) THEN
                V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                   INSERT INTO INFADICMAPA
                      (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                   VALUES
                      (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTETOT,2));
                ELSE
                   INSERT INTO ITMAPARECUP
                      (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                       NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                   VALUES
                      (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTETOT,2),
                       V_NRLANCTONF, V_CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'N');
                END IF;
             END IF;

          /*INICIALIZA AS VARIVEIS DA ROTINA*/
          V_CDFILIAL   := NULL;
          V_NRLANCTONF := NULL;
          V_VRAJUSTE   := 0;

          /*AJUSTES NAS SADAS*/
          ELSIF (C_AJUSTEAUTO.IDRATEIOPADRAO = 'SAI') OR (C_AJUSTEAUTO.IDRATEIOPADRAO = 'SME') THEN
             /*BUSCA OS VALORES DE NOTAS FISCAIS*/
             FOR C_ITEM IN (SELECT SUM(DECODE(NF.IDENTRSAIDOP,'S',II.VRCONTITIMP,0)) AS VRSAIDA,
                                   SUM(DECODE(NF.IDENTRSAIDOP,'S',DECODE(II.CDFISCALIT,'1',II.VRBASECALCIT,0),0)) AS VRBASESAID,
                                   SUM(DECODE(NF.IDENTRSAIDOP,'S',DECODE(II.CDFISCALIT,'1',II.VRIMPOSTOIT, 0),0)) AS VRIMPSAIDA,
                                   SUM(DECODE(NF.IDENTRSAIDOP,'S',DECODE(II.CDFISCALIT,'1',II.VRADICFECP,  0),0)) AS VRFECPSAIDA,
                                   II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, NF.CDFILIEMIT AS CDFILIRATEIO
                              FROM ITEMPROIMPOS II, ITEMPRODUTO IT, PRODUTO PR, IMPOSTO IM, NOTAFISCAL NF,
                                   (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                      FROM IMPOSTONF I
                                     WHERE I.NRSEQUMAPAPU = P_NRSEQUMAPAPU) IP,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDTIPOOPER
                                      FROM RATFISTPOPERAC R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISTPOPERAC R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RT,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCFOPPADRAO
                                      FROM RATFISCFOPPADRAO R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISCFOPPADRAO R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RC,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDPRODUTO
                                      FROM RATFISPRODUTO R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISPRODUTO R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RP,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.IDTPPART, R.CDPARTICIPANTE
                                      FROM RATFISPARTICIP R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISPARTICIP R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RF,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCST
                                      FROM RATFISCST R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISCST R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RS,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.VRALIQUOTA
                                      FROM RATFISALIQ R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', -1 FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISALIQ R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RL,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCLASFISC
                                      FROM RATFISNCM R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISNCM R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RN
                             WHERE IP.CDFILIAL       = II.CDFILIAL
                               AND IP.NRLANCTONF     = II.NRLANCTONF
                               AND II.CDIMPOSTO      = IM.CDIMPOSTO
                               AND IM.CDIMPOSTONFE   = P_CDIMPOSTO
                               AND NVL(II.NRITPROIMPOS,'1') <> '3'
                               AND II.CDFILIAL       = NF.CDFILIAL
                               AND II.NRLANCTONF     = NF.NRLANCTONF
                               AND NF.IDENTRSAIDOP   = 'S'
                               AND RT.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RT.IDENTRSAIDOP
                               AND (NF.CDTIPOOPER = RT.CDTIPOOPER OR RT.CDTIPOOPER = 'T')
                               AND RC.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RC.IDENTRSAIDOP
                               AND (II.CDFISCOPERIT = RC.CDCFOPPADRAO OR RC.CDCFOPPADRAO = 'T')
                               AND II.CDFILIAL       = IT.CDFILIAL
                               AND II.NRLANCTONF     = IT.NRLANCTONF
                               AND II.NRSEQITPROD    = IT.NRSEQITPROD
                               AND RP.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RP.IDENTRSAIDOP
                               AND (IT.CDPRODUTO = RP.CDPRODUTO OR RP.CDPRODUTO = 'T')
                               AND RS.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RS.IDENTRSAIDOP
                               AND (II.CDSITUTRIBITNFE = RS.CDCST OR RS.CDCST = 'T')
                               AND RL.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RL.IDENTRSAIDOP
                               AND (II.VRALIQITEM = RL.VRALIQUOTA OR RL.VRALIQUOTA = -1)
                               AND IT.CDPRODUTO      = PR.CDPRODUTO
                               AND RN.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RN.IDENTRSAIDOP
                               AND (NVL(IT.CDPRODNCMTRANS,PR.CDCLASFISC) = RN.CDCLASFISC OR RN.CDCLASFISC = 'T')
                               AND RF.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RF.IDENTRSAIDOP
                               AND ((NF.IDORIGDESTNF = RF.IDTPPART AND CASE WHEN NF.IDORIGDESTNF = 'F' THEN NF.CDFORNECED
                                                                            WHEN NF.IDORIGDESTNF = 'C' THEN NF.CDCLIENTE
                                                                            WHEN NF.IDORIGDESTNF = 'L' THEN NF.CDFILIRECE END = RF.CDPARTICIPANTE)
                                                                    OR (RF.CDPARTICIPANTE = 'T'))
                             GROUP BY II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, NF.CDFILIEMIT
                             ORDER BY II.CDFILIAL, II.NRLANCTONF) LOOP

                /*CALCULA O VALOR ITEM A ITEM*/
                V_VRCONTABIL := NVL(C_ITEM.VRSAIDA,0);
                V_VRBASECALC := NVL(C_ITEM.VRBASESAID,0);
                V_VRIMPOSTO  := NVL(C_ITEM.VRIMPSAIDA,0);
                V_VRFECP     := NVL(C_ITEM.VRFECPSAIDA,0);
                V_VRAJUSTE   := 0;

                /******** Monta o select, considerando a frmula cadastrada pelo usurio ********/
                V_SQLFORMULA := 'SELECT ' || C_AJUSTEAUTO.DSFORMULA || ' AS VRAJUSTE
                                   FROM (SELECT ' || REPLACE(V_VRIMPOSTO, ',','.') || ' AS I,
                                                ' || REPLACE(V_VRBASECALC,',','.') || ' AS B,
                                                ' || REPLACE(V_VRCONTABIL,',','.') || ' AS C,
                                                ' || REPLACE(V_VRFECP,    ',','.') || ' AS F
                                           FROM DUAL)';

                /******** Executa o select e faz o tratamento de erros ********/
                BEGIN
                   EXECUTE IMMEDIATE V_SQLFORMULA INTO V_VRAJUSTE;
                EXCEPTION
                   WHEN OTHERS THEN
                      RAISE_APPLICATION_ERROR(-20501,V_SQLFORMULA||'_'||SQLERRM(SQLCODE),TRUE);
                END;

                /*SALVA A FILIAL DO RATEIO EM UMA VARIVEL PORQUE O LTIMO AJUSTE POR DOCUMENTO PRECISAR SER INSERIDO FORA DO LOOP*/
                V_FILIRATEIO  := C_ITEM.CDFILIRATEIO;

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, MAS INSERIDO NO MAPA UM NICO AJUSTE*/
                IF C_AJUSTEAUTO.IDTIPOCALCDOC = 'T' THEN
                   V_VRAJUSTETOT := NVL(V_VRAJUSTETOT,0) + NVL(V_VRAJUSTE,0);
                   /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                   INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, NVL(V_NRSEQAJUSTE,0)+1, ROUND(V_VRAJUSTE,2), V_FILIRATEIO);

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, MAS INSERIDO NO MAPA UM AJUSTE POR NOTA FISCAL*/
                ELSIF C_AJUSTEAUTO.IDTIPOCALCDOC = 'D' THEN
                   IF (V_CDFILIAL||V_NRLANCTONF IS NULL) THEN
                      V_CDFILIAL   := C_ITEM.CDFILIAL;
                      V_NRLANCTONF := C_ITEM.NRLANCTONF;
                   END IF;
                   V_VRAJUSTEDOC :=  NVL(V_VRAJUSTEDOC,0) + NVL(V_VRAJUSTE,0);
                   IF (V_CDFILIAL||V_NRLANCTONF <> C_ITEM.CDFILIAL||C_ITEM.NRLANCTONF) THEN
                      IF V_VRAJUSTEDOC > 0 THEN
                         V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                         IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                            INSERT INTO INFADICMAPA
                               (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                            VALUES
                               (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2));
                         ELSE
                            INSERT INTO ITMAPARECUP
                               (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                                NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                            VALUES
                               (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2),
                                V_NRLANCTONF,V_CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'D');
                         END IF;
                         /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                         INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTEDOC,2), V_FILIRATEIO);
                      END IF;
                      V_CDFILIAL    := C_ITEM.CDFILIAL;
                      V_NRLANCTONF  := C_ITEM.NRLANCTONF;
                      V_VRAJUSTEDOC := 0;
                   END IF;

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, INSERIDO NO MAPA UM AJUSTE PARA CADA ITEM*/
                ELSIF C_AJUSTEAUTO.IDTIPOCALCDOC = 'I' THEN
                   IF (V_VRAJUSTE > 0) THEN
                      /*INSERE O AJUSTE PARA O ITEM QUANDO  VALOR INFORMATIVO*/
                      IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                         V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                         INSERT INTO INFADICMAPA
                            (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                         VALUES
                            (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTE,2));
                      ELSE
                         /*INSERE O AJUSTE PARA A NOTA, OU ATUALIZA O VALOR CASO J TENHA SIDO INCLUDO ALGUM ITEM PARA ESSA NOTA*/
                         IF (V_CDFILIAL||V_NRLANCTONF IS NULL) OR (V_CDFILIAL||V_NRLANCTONF <> C_ITEM.CDFILIAL||C_ITEM.NRLANCTONF) THEN
                            V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                            INSERT INTO ITMAPARECUP
                               (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                                NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                            VALUES
                               (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTE,2),
                                C_ITEM.NRLANCTONF, C_ITEM.CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'I');
                            V_CDFILIAL   := C_ITEM.CDFILIAL;
                            V_NRLANCTONF := C_ITEM.NRLANCTONF;
                         ELSE
                            UPDATE ITMAPARECUP
                               SET VRITEMMAPR = NVL(VRITEMMAPR,0) + ROUND(NVL(V_VRAJUSTE,0),2)
                             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU
                               AND IDTIPOITMAPR = C_AJUSTEAUTO.IDTPAJUSTE
                               AND NRSEQITMAPR  = LPAD(V_NRSEQAJUSTE,10,'0');
                         END IF;

                         /*INSERE O DETALHAMENTO DO ITEM*/
                         NOVO_CODIGO('DETITMAPARECUP',V_NRSEQDETITMAPA);
                         INSERT INTO DETITMAPARECUP
                            (NRSEQDETITMAPA, NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, CDFILIAL,
                             NRLANCTONF, NRSEQITPROD, CDIMPOSTO, VRIMPOSTOIT)
                         VALUES
                            (TO_NUMBER(V_NRSEQDETITMAPA), P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_ITEM.CDFILIAL,
                             C_ITEM.NRLANCTONF, C_ITEM.NRSEQITPROD, V_CDIMPOSTO, ROUND(V_VRAJUSTE,2));
                      END IF;
                      /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                      INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTE,2), V_FILIRATEIO);
                   END IF;
                END IF;
             END LOOP;
             /*DEPOIS QUE TERMINAR O LOOP, INSERE O AJUSTE PARA A LTIMA NOTA NO CASO DE AJUSTE POR DOCUMENTO, O AJUSTE TOTAL NAO SERA INSERIDO NESSE MOMENTO POIS AINDA TEM O CLCULO DAS VENDAS*/
             IF C_AJUSTEAUTO.IDTIPOCALCDOC = 'D' AND V_VRAJUSTEDOC > 0 THEN
                V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                   INSERT INTO INFADICMAPA
                      (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                   VALUES
                      (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2));
                ELSE
                    INSERT INTO ITMAPARECUP
                       (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                        NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                    VALUES
                       (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2),
                        V_NRLANCTONF, V_CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'D');
                END IF;
                /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTEDOC,2), V_FILIRATEIO);
             END IF;
             /*BUSCA OS VALORES DAS VENDAS*/
             FOR C_ITEM IN (SELECT SUM(TRUNC((IT.QTPRODVEND  * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2)) AS VRSAIDA,
                                   SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T'
                                            THEN CASE WHEN II.VRPRBCREDUICMS > 0
                                                      THEN II.VRBASECALCREDUZ
                                                      ELSE TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2) END
                                            ELSE 0 END) AS VRBASESAID,
                                   SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T'
                                            THEN CASE WHEN II.VRPRBCREDUICMS > 0
                                                      THEN NVL(II.VRIMPOPRODREDUZ,0)
                                                      ELSE NVL(VRIMPOPRODIT,0) END
                                            ELSE 0 END) AS VRIMPSAIDA,
                                   SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T'
                                            THEN NVL(II.VRIMPICMSFCP,0)
                                            ELSE 0 END) AS VRFECPSAIDA,
                                   IP.CDFILIAL, IP.NRLANCTONF, IT.CDFILIAL AS CDFILIALVND, IT.CDCAIXA, IT.NRSEQVENDA, IT.NRSEQUITVEND, NF.CDFILIEMIT AS CDFILIRATEIO
                              FROM ITVENDAIMPOS II, ITEMVENDA IT, PRODUTO PR, IMPOSTO IM, NOTAFISCAL NF, RATEIOPADRAOFIS RA,
                                   (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF, R.CDFILIALVENDA, R.CDCAIXA, R.NRSEQVENDA
                                      FROM IMPOSTONF I, RELACNFCEAPROV R, VENDA V
                                     WHERE I.NRSEQUMAPAPU  = P_NRSEQUMAPAPU
                                       AND I.CDFILIAL      = R.CDFILIALNOTA
                                       AND I.NRLANCTONF    = R.NRLANCTONF
                                       AND R.CDFILIALVENDA = V.CDFILIAL
                                       AND R.CDCAIXA       = V.CDCAIXA
                                       AND R.NRSEQVENDA    = V.NRSEQVENDA
                                       AND V.IDSITUVENDA   = 'O') IP,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDTIPOOPER
                                      FROM RATFISTPOPERAC R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISTPOPERAC R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RT,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCFOPPADRAO
                                      FROM RATFISCFOPPADRAO R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISCFOPPADRAO R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RC,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDPRODUTO
                                      FROM RATFISPRODUTO R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISPRODUTO R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RP,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.IDTPPART, R.CDPARTICIPANTE
                                      FROM RATFISPARTICIP R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISPARTICIP R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RF,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCST
                                      FROM RATFISCST R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISCST R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RS,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.VRALIQUOTA
                                      FROM RATFISALIQ R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', -1 FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISALIQ R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RL,
                                   (SELECT R.CDRATEIOPADRAO, R.IDENTRSAIDOP, R.CDCLASFISC
                                      FROM RATFISNCM R
                                     WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                     UNION ALL
                                    SELECT C_AJUSTEAUTO.CDCRITAJUSTE, 'S', 'T' FROM DUAL
                                     WHERE NOT EXISTS (SELECT * FROM RATFISNCM R
                                                        WHERE R.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                                                          AND R.IDENTRSAIDOP   = 'S')) RN
                             WHERE IP.CDFILIALVENDA       = II.CDFILIAL
                               AND IP.CDCAIXA        = II.CDCAIXA
                               AND IP.NRSEQVENDA     = II.NRSEQVENDA
                               AND II.CDIMPOSTO      = IM.CDIMPOSTO
                               AND IP.CDFILIAL       = NF.CDFILIAL
                               AND IP.NRLANCTONF     = NF.NRLANCTONF
                               AND NF.IDENTRSAIDOP   = 'S'
                               AND NF.IDSISTEMA      = 'FIS'
                               AND RT.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RT.IDENTRSAIDOP
                               AND (NF.CDTIPOOPER    = RT.CDTIPOOPER OR RT.CDTIPOOPER = 'T')
                               AND RC.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RC.IDENTRSAIDOP
                               AND (II.CDCFOPPROD    = RC.CDCFOPPADRAO OR RC.CDCFOPPADRAO = 'T')
                               AND II.CDFILIAL       = IT.CDFILIAL
                               AND II.CDCAIXA        = IT.CDCAIXA
                               AND II.NRSEQVENDA     = IT.NRSEQVENDA
                               AND II.NRSEQUITVEND   = IT.NRSEQUITVEND
                               AND RP.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RP.IDENTRSAIDOP
                               AND (IT.CDPRODUTO     = RP.CDPRODUTO OR RP.CDPRODUTO = 'T')
                               AND RS.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RS.IDENTRSAIDOP
                               AND (II.CDCSTPRODI    = RS.CDCST OR RS.CDCST = 'T')
                               AND RL.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RL.IDENTRSAIDOP
                               AND (II.VRPEALPRODIT  = RL.VRALIQUOTA OR RL.VRALIQUOTA = -1)
                               AND IT.CDPRODUTO      = PR.CDPRODUTO
                               AND RN.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RN.IDENTRSAIDOP
                               AND (NVL(IT.CDCLASFISC,PR.CDCLASFISC) = RN.CDCLASFISC OR RN.CDCLASFISC = 'T')
                               AND RF.CDRATEIOPADRAO = C_AJUSTEAUTO.CDCRITAJUSTE
                               AND NF.IDENTRSAIDOP   = RF.IDENTRSAIDOP
                               AND ((NF.IDORIGDESTNF = RF.IDTPPART AND CASE WHEN NF.IDORIGDESTNF = 'F' THEN NF.CDFORNECED
                                                                            WHEN NF.IDORIGDESTNF = 'C' THEN NF.CDCLIENTE
                                                                            WHEN NF.IDORIGDESTNF = 'L' THEN NF.CDFILIRECE END = RF.CDPARTICIPANTE)
                                                                    OR (RF.CDPARTICIPANTE = 'T'))
                             GROUP BY IP.CDFILIAL, IP.NRLANCTONF, IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA, IT.NRSEQUITVEND, NF.CDFILIEMIT
                             ORDER BY IP.CDFILIAL, IP.NRLANCTONF, IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA) LOOP

                /*CALCULA O VALOR ITEM A ITEM*/
                V_VRCONTABIL := NVL(C_ITEM.VRSAIDA,0);
                V_VRBASECALC := NVL(C_ITEM.VRBASESAID,0);
                V_VRIMPOSTO  := NVL(C_ITEM.VRIMPSAIDA,0);
                V_VRFECP     := NVL(C_ITEM.VRFECPSAIDA,0);
                V_VRAJUSTE   := 0;

                /******** Monta o select, considerando a frmula cadastrada pelo usurio ********/
                V_SQLFORMULA := 'SELECT ' || C_AJUSTEAUTO.DSFORMULA || ' AS VRAJUSTE
                                   FROM (SELECT ' || REPLACE(V_VRIMPOSTO, ',','.') || ' AS I,
                                                ' || REPLACE(V_VRBASECALC,',','.') || ' AS B,
                                                ' || REPLACE(V_VRCONTABIL,',','.') || ' AS C,
                                                ' || REPLACE(V_VRFECP,    ',','.') || ' AS F
                                           FROM DUAL)';

                /******** Executa o select e faz o tratamento de erros ********/
                BEGIN
                   EXECUTE IMMEDIATE V_SQLFORMULA INTO V_VRAJUSTE;
                EXCEPTION
                   WHEN OTHERS THEN
                      RAISE_APPLICATION_ERROR(-20501,V_SQLFORMULA||'_'||SQLERRM(SQLCODE),TRUE);
                END;
                /*SALVA A FILIAL DO RATEIO EM UMA VARIVEL PORQUE O LTIMO AJUSTE POR DOCUMENTO PRECISAR SER INSERIDO FORA DO LOOP*/
                V_FILIRATEIO  := C_ITEM.CDFILIRATEIO;

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, MAS INSERIDO NO MAPA UM NICO AJUSTE*/
                IF C_AJUSTEAUTO.IDTIPOCALCDOC = 'T' THEN
                   V_VRAJUSTETOT := NVL(V_VRAJUSTETOT,0) + NVL(V_VRAJUSTE,0);
                   /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                   INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, NVL(V_NRSEQAJUSTE,0)+1, ROUND(V_VRAJUSTE,2), V_FILIRATEIO);

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, MAS INSERIDO NO MAPA UM AJUSTE POR NOTA FISCAL*/
                ELSIF C_AJUSTEAUTO.IDTIPOCALCDOC = 'D' THEN
                   IF (V_CDFILIAL||V_NRLANCTONF IS NULL) THEN
                      V_CDFILIAL   := C_ITEM.CDFILIAL;
                      V_NRLANCTONF := C_ITEM.NRLANCTONF;
                   END IF;
                   V_VRAJUSTEDOC := NVL(V_VRAJUSTEDOC,0) + NVL(V_VRAJUSTE,0);
                   IF (V_CDFILIAL||V_NRLANCTONF <> C_ITEM.CDFILIAL||C_ITEM.NRLANCTONF) THEN
                      IF V_VRAJUSTEDOC > 0 THEN
                         V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                         IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                            INSERT INTO INFADICMAPA
                               (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                            VALUES
                               (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2));
                         ELSE
                            INSERT INTO ITMAPARECUP
                               (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                                NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                            VALUES
                               (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2),
                                V_NRLANCTONF,V_CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'D');
                         END IF;
                         /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                         INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTEDOC,2), V_FILIRATEIO);
                      END IF;
                      V_CDFILIAL    := C_ITEM.CDFILIAL;
                      V_NRLANCTONF  := C_ITEM.NRLANCTONF;
                      V_VRAJUSTEDOC := 0;
                   END IF;

                /*ROTINA DE AJUSTE CALCULADO POR ITEM, INSERIDO NO MAPA UM AJUSTE PARA CADA ITEM*/
                ELSIF C_AJUSTEAUTO.IDTIPOCALCDOC = 'I' THEN
                   IF (V_VRAJUSTE > 0) THEN
                      /*INSERE O AJUSTE PARA O ITEM QUANDO  VALOR INFORMATIVO*/
                      IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                         V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                         INSERT INTO INFADICMAPA
                            (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                         VALUES
                            (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTE,2));
                      ELSE
                         /*INSERE O AJUSTE PARA A NOTA, OU ATUALIZA O VALOR CASO J TENHA SIDO INCLUDO ALGUM ITEM PARA ESSA NOTA*/
                         IF (V_CDFILIAL||V_NRLANCTONF IS NULL) OR (V_CDFILIAL||V_NRLANCTONF <> C_ITEM.CDFILIAL||C_ITEM.NRLANCTONF) THEN
                            V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                            INSERT INTO ITMAPARECUP
                               (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                                NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                            VALUES
                               (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTE,2),
                                C_ITEM.NRLANCTONF, C_ITEM.CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'I');
                            V_CDFILIAL   := C_ITEM.CDFILIAL;
                            V_NRLANCTONF := C_ITEM.NRLANCTONF;
                         ELSE
                            UPDATE ITMAPARECUP
                               SET VRITEMMAPR = NVL(VRITEMMAPR,0) + ROUND(NVL(V_VRAJUSTE,0),2)
                             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU
                               AND IDTIPOITMAPR = C_AJUSTEAUTO.IDTPAJUSTE
                               AND NRSEQITMAPR  = LPAD(V_NRSEQAJUSTE,10,'0');
                         END IF;

                         /*INSERE O DETALHAMENTO DO ITEM*/
                         NOVO_CODIGO('DETITMAPARECUP',V_NRSEQDETITMAPA);
                         INSERT INTO DETITMAPARECUP
                            (NRSEQDETITMAPA, NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, CDFILIAL,
                             NRLANCTONF, CDIMPOSTO, VRIMPOSTOIT,
                             CDFILIALVND, CDCAIXA, NRSEQVENDA, NRSEQUITVEND)
                         VALUES
                            (TO_NUMBER(V_NRSEQDETITMAPA), P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_ITEM.CDFILIAL,
                             C_ITEM.NRLANCTONF, V_CDIMPOSTO, ROUND(V_VRAJUSTE,2),
                             C_ITEM.CDFILIALVND, C_ITEM.CDCAIXA, C_ITEM.NRSEQVENDA, C_ITEM.NRSEQUITVEND);
                      END IF;
                      /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                      INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTE,2), V_FILIRATEIO);
                   END IF;
                END IF;
             END LOOP;
             /*INSERE O AJUSTE PARA A LTIMA NOTA, NO CASO DE AJUSTE POR DOCUMENTO*/
             IF (C_AJUSTEAUTO.IDTIPOCALCDOC = 'D') AND (V_VRAJUSTEDOC > 0) THEN
                V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                   INSERT INTO INFADICMAPA
                      (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                   VALUES
                      (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2));
                ELSE
                   INSERT INTO ITMAPARECUP
                      (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                       NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                   VALUES
                      (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTEDOC,2),
                       V_NRLANCTONF, V_CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'D');
                END IF;
                /*INSERE O RATEIO NA TABELA, CASO O RATEIO DA CONTABILIZAO SEJA PELO PRPRIO CLCULO*/
                INSERE_TABELA_RATEIO (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, V_NRSEQAJUSTE, ROUND(V_VRAJUSTEDOC,2), V_FILIRATEIO);
             END IF;
             /*INSERE O AJUSTE NO CASO DE AJUSTE NICO*/
             IF (C_AJUSTEAUTO.IDTIPOCALCDOC = 'T') AND (V_VRAJUSTETOT > 0) THEN
                V_NRSEQAJUSTE := NVL(V_NRSEQAJUSTE,0) + 1;
                IF C_AJUSTEAUTO.IDTPAJUSTE = 'IA' THEN
                   INSERT INTO INFADICMAPA
                      (NRSEQUMAPAPU, NRSEQINFADIC, IDORIGEMINF, CDINFADICMAPA, DSINFADICMAPA, VRINFADICMAPA)
                   VALUES
                      (P_NRSEQUMAPAPU, LPAD(V_NRSEQAJUSTE,5,'0'), 'A', C_AJUSTEAUTO.CDAJUSTEEEFD, C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTETOT,2));
                ELSE
                   INSERT INTO ITMAPARECUP
                      (NRSEQUMAPAPU, IDTIPOITMAPR, NRSEQITMAPR, DSITEMMAPR, VRITEMMAPR,
                       NRLANCTONF, CDFILIAL, CDAJUSTEITMAPA, IDAJUSTEAUTO, IDCOMPOEC197)
                   VALUES
                      (P_NRSEQUMAPAPU, C_AJUSTEAUTO.IDTPAJUSTE, LPAD(V_NRSEQAJUSTE,10,'0'), C_AJUSTEAUTO.DSAJUSTEEFDICMS, ROUND(V_VRAJUSTETOT,2),
                       V_NRLANCTONF, V_CDFILIAL, C_AJUSTEAUTO.CDAJUSTEEEFD, 'S', 'N');
                END IF;
             END IF;
          END IF;
       END IF;
   END LOOP;
END;
/